package model.fish.bad;

import model.ILambda;
import model.fish.display.ImageFishDisplay;
import sysModel.fish.AFish;

import java.awt.*;

/**
 * A fish that tries to create a new thread.
 *
 * @author Mathias Ricken
 */
public class ThreadFish extends AFish {
    /**
     * Constructor.
     *
     * @param fishColor color of the fish
     */
    public ThreadFish(Color fishColor) {
        super(fishColor, new ImageFishDisplay("smallfish.gif", 3.0 * Math.PI / 2.0));
    }

    /**
     * Move the fish.
     */
    protected void move() {
        tryMoveFwd(new ILambda() {
            public Object apply(Object param) {
                // change security manager
                Runnable r = new Runnable() {
                    /**
                     * When an object implementing interface <code>Runnable</code> is used to create a thread, starting
                     * the thread causes the object's <code>run</code> method to be called in that separately executing
                     * thread.
                     * <p/>
                     * The general contract of the method <code>run</code> is that it may take any action whatsoever.
                     *
                     * @see Thread#run()
                     */
                    public void run() {
                        while(true) {
                            System.out.println("tid" + Thread.currentThread().getId());
                            try {
                                Thread.sleep(1000);
                            }
                            catch(InterruptedException ie) {
                                // do nothing
                            }
                        }
                    }
                };
                Thread t = new Thread(r);
                t.start();
                return null;
            }
        }, new ILambda() {
            public Object apply(Object param) {
                // move forward
                ((ILambda)param).apply(null);
                return null;
            }
        });
    }
}
